%------------------------------------
%% Ivan lopez                       -
% Class: EE444                      -
% 10/16/2017                        -
% Triangulation Map Radar           -
%% ----------------------------------
delete(instrfindall);
clc;
clear all;


 C=input('Enter C (distance between sensors): ');
 yoff=input('Enter y offset from Maze: ');
 xoff=input('Enter x offset from Maze: ');
 
scan=1;
 while (scan==1)
%% Customize graph
figure('units','normalized','outerposition',[0 0 1 1]);
whitebg('black');
%% Draw Circles Scales 
th = linspace(0,pi,1000);
Rmax_c=80;
Rmin_c=10;
R = Rmin_c:10:Rmax_c;
for i=1:length(R)
x = R(i)*cos(th);
y = R(i)*sin(th);
plot(x,y,'Color', [0.60 , 0.80 , 0.2] ,'LineWidth',1);                          % [0.60 , 0.80 , 0.2] Green color
hold on;
end
%% Draw Axis data in 30 degress messages
x1 = [0 ,Rmax_c*cos(pi/3), Rmax_c*cos(pi/6) ,-Rmax_c*cos(pi/3), -Rmax_c*cos(pi/6) ];
y1 = [Rmax_c ,Rmax_c*sin(pi/3), Rmax_c*sin(pi/6) ,Rmax_c*sin(pi/3), Rmax_c*sin(pi/6) ];
y0 = [0 0 0 0 0];
x0 = [0 0 0 0 0];

for i=1:length(x0)
hold on;
plot([x0(i),x1(i)],[y0(i),y1(i)] ,'Color', [0.60 , 0.80 , 0.2],'LineWidth',2);  % [0.60 , 0.80 , 0.2] Green color
end
%% Draw lines Per degree
for i=1:180 
hold on;
[x, y] = pol2cart(i*(pi/180), Rmax_c);
h(i) = plot([0,x],[0,y],'g','LineWidth',.5);
end
%% Define serial port to connect to arduino
myArduino = serial('COM15');             
myArduino.BaudRate=9600;                               
fopen(myArduino);
i=0;
%% Draw Sonar Data for left sensor on given range
for ii=10:90
data = fscanf(myArduino);      % Get data from arduino
[th, r] = strtok(data);        % uses white space as delimiter
th = real(str2num(th)); 
r = str2num(r);


if (isempty(th)~=1)&&(isempty(r)~=1)&&(length(r)==1)&&(length(th)==1)   % Filter out empty data
    logR_L(ii)=r;
    logTh_L(ii)=th;

    set(h(th),'color','r');                     % Color of data read 
    [x0, y0] = pol2cart(th*(pi/180), Rmax_c);   % note theta must be in rads for Pol2cart
    [x, y] = pol2cart(th*(pi/180), r);          
    set(h(th),'XData',[x0,x]);                  % replace default data h with new data
    set(h(th),'YData',[y0,y]);
    m = plot([0,x0],[0,y0],'r','LineWidth',3);
    drawnow
    delete(m);
end

%% Draw Sonar Data for Right sensor on given range
end
for ii=91:170
data = fscanf(myArduino);
[th, r] = strtok(data);% uses white space as delimiter
th = real(str2num(th));
r = str2num(r);

if (isempty(th)~=1)&&(isempty(r)~=1)&&(length(r)==1)&&(length(th)==1) % Filter out empty data
    i=i+1;
    logR_R(ii-90)=r;
    logTh_R(ii-90)=th;

    set(h(th),'color','b');                     % Color of data read 
    [x0, y0] = pol2cart(th*(pi/180), Rmax_c);   % note: theta must be in radians
    [x, y] = pol2cart(th*(pi/180), r);          
    set(h(th),'XData',[x0,x]);                  % replace default data h with new data
    set(h(th),'YData',[y0,y]);                  % sets the value of the specified property for the graphics object with handle H
    m = plot([0,x0],[0,y0],'r','LineWidth',3); 
    drawnow
    delete(m);
end
end

%% Filter Signal
logR_L=logR_L(logR_L>0);
logR_R=logR_R(logR_R>0);
L=mode(logR_L(logR_L<40));
R=mode(logR_R(logR_R<40));

%% Triangulate
%C=25;
%yoff=10;
%xoff=1;
angleR=acos((R^2-L^2-C^2)/(-2*L*C));
xx=L*cos(angleR)-xoff;
yy=L*sin(angleR)-yoff;
if ((xx==real(xx))&& (yy==real(yy))&&(real(yy)>=0))
%% Plot in Maze
[x,y]=gridCoord(xx,yy);
Maze=checkMaze(x,y);
figure
imshow(Maze)
end
fclose(myArduino);
scan=input('input 1 if you want to scan again: ');
 end



